"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const types = __importStar(require("@babel/types"));
const types_1 = require("@babel/types");
exports.default = (_, config) => {
    if (config.libraryName === undefined) {
        console.warn('config.libraryName is required');
        return {};
    }
    return {
        visitor: {
            ImportDeclaration(nodePath, state) {
                const sourceName = nodePath.node.source.value;
                const libraryDirectory = config.libraryDirectory ? `/${config.libraryDirectory}` : '';
                if (sourceName !== config.libraryName) {
                    return;
                }
                const sourceValue = nodePath.node.source.value;
                const memberImports = nodePath.node.specifiers.filter((specifier) => types_1.isImportSpecifier(specifier));
                const fullImports = nodePath.node.specifiers.filter((specifier) => !types_1.isImportSpecifier(specifier));
                if (memberImports.length > 0) {
                    const newNodes = memberImports.map((item) => {
                        const localName = item.local.name;
                        const importedName = item.imported.name;
                        const newSource = types.stringLiteral(`${sourceValue}${libraryDirectory}/${importedName}`);
                        const newSpecifier = types.importDefaultSpecifier(types.identifier(localName));
                        const newNode = types.importDeclaration([newSpecifier], newSource);
                        return newNode;
                    });
                    if (fullImports.length > 0) {
                        newNodes.unshift(types.importDeclaration(fullImports, nodePath.node.source));
                    }
                    nodePath.replaceWithMultiple(newNodes);
                }
            }
        }
    };
};
//# sourceMappingURL=index.js.map